﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using Telerik.Windows.Controls.Diagrams.Extensions.ViewModels;

namespace SilverlightApplication1
{
	public class GraphSource : SerializableGraphSourceBase<OrgItem, OrgLink>
	{
		public override string GetLinkUniqueId(OrgLink link)
		{
			return link.Source.Label + "." + link.Target.Label;
		}

		public override string GetNodeUniqueId(OrgItem node)
		{
			return node.Label;
		}

		public override void SerializeNode(OrgItem node, Telerik.Windows.Diagrams.Core.SerializationInfo info)
		{
			base.SerializeNode(node, info);
			info["Label"] = node.Label;
			info["ImgUriString"] = node.ImageSource.UriSource.OriginalString;
		}

		public override OrgItem DeserializeNode(Telerik.Windows.Diagrams.Core.IShape shape, Telerik.Windows.Diagrams.Core.SerializationInfo info)
		{
			base.DeserializeNode(shape, info);
			if (info["Label"] != null && info["ImgUriString"] != null)
			{
				OrgItem item =  new OrgItem(info["Label"].ToString())
				{
					ImageSource = new BitmapImage(new Uri(info["ImgUriString"].ToString(), UriKind.RelativeOrAbsolute))
				};
				return item;
			}	
			return null;
		}
	}
}
