﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls.Diagrams;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.Diagrams.Extensions;
using Telerik.Windows.Diagrams.Core;
using System.Windows.Media.Imaging;

namespace SilverlightApplication1
{
	public partial class MainPage : UserControl
	{
		private string digramStateXmlString;

		public MainPage()
		{
			InitializeComponent();
			this.BindGraphSource();	
		}

		private void BindGraphSource()
		{
			GraphSource source = new GraphSource();
			OrgItem rootItem = new OrgItem() { Label = "CEO", ImageSource = new BitmapImage( new Uri("Images/DelPiero.jpg", UriKind.RelativeOrAbsolute)) };
			source.AddNode(rootItem);
			for (int i = 0; i < 2; i++)
			{
				OrgItem child = new OrgItem() { Label = "Manager " + i, ImageSource = new BitmapImage(new Uri("Images/GianluigiBuffon.jpg", UriKind.RelativeOrAbsolute)) };
				source.AddNode(child);
				source.AddLink(new OrgLink(rootItem, child));
				for (int j = 0; j < 1; j++)
				{
					OrgItem subchild = new OrgItem() { Label = "Team LEad" + i + "." + j, ImageSource = new BitmapImage(new Uri("Images/PavelNedved.jpg", UriKind.RelativeOrAbsolute)) };
					source.AddNode(subchild);
					source.AddLink(new OrgLink(child, subchild));
				}
			}
			this.diagram.GraphSource = source;
		}

		private void RadButton_Click(object sender, RoutedEventArgs e)
		{
			this.PrepareShapesForTipOverTreeRouting();
			TreeLayoutSettings settings = new TreeLayoutSettings()
			{
				TreeLayoutType = TreeLayoutType.TipOverTree,
				VerticalDistance = 100,
				UnderneathHorizontalOffset = 50,
				UnderneathVerticalTopOffset = 50,
				UnderneathVerticalSeparation = 60
			};
			settings.Roots.Add(this.diagram.Shapes[0]);
			OrgTreeRouter router = new OrgTreeRouter()
			{
				TreeLayoutType = TreeLayoutType.TipOverTree,
				ConnectionOuterSpacing = 20,
			};
			this.diagram.RoutingService.Router = router;
			this.diagram.Layout(LayoutType.Tree, settings);
		}

		private void PrepareShapesForTipOverTreeRouting()
		{
			foreach (var item in this.diagram.Shapes)
			{
				var connector = new RadDiagramConnector() { Offset = new Point(0.2, 1) };
				connector.Name =  "aa" + DateTime.Now.Millisecond;
				item.Connectors.Add(connector);
			}
		}

		private void RadButton_Click_1(object sender, RoutedEventArgs e)
		{
			this.digramStateXmlString = this.diagram.Save();
		}

		private void RadButton_Click_2(object sender, RoutedEventArgs e)
		{
			if (this.digramStateXmlString != null)
			{
				this.diagram.Load(this.digramStateXmlString);
			}
		}

		}
		}